class PositionClassifier(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : NoneType
  prepare_data_per_node : bool
  allow_zero_length_dataloader_with_multiple_devices : bool
  _log_hyperparams : bool
  _dtype : int
  _device : Device
  _trainer : NoneType
  _current_fx_name : NoneType
  _automatic_optimization : bool
  _metric_attributes : NoneType
  _compiler_ctx : NoneType
  _fabric : NoneType
  _hparams_name : str
  embedding : __torch__.torch.nn.modules.sparse.Embedding
  qn : __torch__.transformer.Transformer
  fc2 : __torch__.torch.nn.modules.linear.___torch_mangle_4.Linear
  bases_fc : __torch__.torch.nn.modules.linear.___torch_mangle_5.Linear
  def forward(self: __torch__.model.PositionClassifier,
    bases: Tensor,
    qualities: Tensor,
    lengths: Tensor,
    target_positions: List[Tensor]) -> Tuple[Tensor, Tensor]:
    embedding = self.embedding
    bases_embeds = (embedding).forward(bases, )
    _0 = [bases_embeds, torch.unsqueeze(qualities, -1)]
    x = torch.cat(_0, -1)
    x0 = torch.permute(x, [0, 3, 1, 2])
    qn = self.qn
    sliced_sequences_concatenated = (qn).forward(x0, target_positions, lengths, )
    fc2 = self.fc2
    _1 = (fc2).forward(sliced_sequences_concatenated, )
    infos_logits = torch.squeeze(_1, -1)
    bases_fc = self.bases_fc
    bases_logits = (bases_fc).forward(sliced_sequences_concatenated, )
    return (infos_logits, bases_logits)
