class ReLU(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : NoneType
  inplace : Final[bool] = False
  def forward(self: __torch__.torch.nn.modules.activation.ReLU,
    input: Tensor) -> Tensor:
    _0 = __torch__.torch.nn.functional.relu(input, False, )
    return _0
class MultiheadAttention(Module):
  __parameters__ = ["in_proj_weight", "q_proj_weight", "k_proj_weight", "v_proj_weight", "in_proj_bias", ]
  __buffers__ = []
  in_proj_weight : Tensor
  q_proj_weight : NoneType
  k_proj_weight : NoneType
  v_proj_weight : NoneType
  in_proj_bias : Tensor
  training : bool
  _is_full_backward_hook : NoneType
  embed_dim : int
  kdim : int
  vdim : int
  _qkv_same_embed_dim : bool
  num_heads : int
  dropout : float
  head_dim : int
  bias_k : Optional[Tensor]
  bias_v : Optional[Tensor]
  add_zero_attn : bool
  out_proj : __torch__.torch.nn.modules.linear.NonDynamicallyQuantizableLinear
  batch_first : Final[bool] = True
  def forward(self: __torch__.torch.nn.modules.activation.MultiheadAttention,
    query: Tensor,
    key: Tensor,
    value: Tensor,
    key_padding_mask: Optional[Tensor]=None,
    need_weights: bool=True,
    attn_mask: Optional[Tensor]=None,
    average_attn_weights: bool=True,
    is_causal: bool=False) -> Tuple[Tensor, Optional[Tensor]]:
    why_not_fast_path = "floating-point masks are not supported for fast path."
    _1 = __torch__.torch.nn.functional._none_or_dtype
    _2 = __torch__.torch.nn.functional._canonical_mask
    _3 = "input not batched; expected query.dim() of 3 but got {}"
    why_not_fast_path0 = "non-self attention was used (query, key, and value are not the same Tensor)"
    _4 = "dtypes of query ({}) and self.in_proj_bias ({}) don\'t match"
    _5 = "dtypes of query ({}) and self.in_proj_weight ({}) don\'t match"
    why_not_fast_path1 = "supplying both src_key_padding_mask and src_mask at the same time                              is not supported with NestedTensor input"
    _6 = __torch__.torch.nn.modules.activation._is_make_fx_tracing
    _7 = __torch__.torch.nn.modules.activation._check_arg_device
    _8 = "some Tensor argument\'s device is neither one of cpu, cuda or {}"
    _9 = __torch__.torch.nn.modules.activation._arg_requires_grad
    why_not_fast_path2 = "grad is enabled and at least one of query or the input/output projection weights or biases requires_grad"
    _10 = "The fast path was not hit because {}"
    _11 = "MultiheadAttention does not support NestedTensor outside of its fast path. "
    _12 = __torch__.torch.nn.functional.multi_head_attention_forward
    _13 = uninitialized(Tuple[Tensor, Tensor])
    if torch.__isnot__(attn_mask, None):
      attn_mask1 = unchecked_cast(Tensor, attn_mask)
      _15 = torch.is_floating_point(attn_mask1)
      _14, attn_mask0 = _15, attn_mask1
    else:
      _14, attn_mask0 = False, attn_mask
    if _14:
      attn_mask3 = unchecked_cast(Tensor, attn_mask0)
      _16, attn_mask2, key_padding_mask0 = True, attn_mask3, key_padding_mask
    else:
      _17 = torch.__isnot__(key_padding_mask, None)
      if _17:
        key_padding_mask2 = unchecked_cast(Tensor, key_padding_mask)
        _19 = torch.is_floating_point(key_padding_mask2)
        _18, key_padding_mask1 = _19, key_padding_mask2
      else:
        _18, key_padding_mask1 = False, key_padding_mask
      _16, attn_mask2, key_padding_mask0 = _18, attn_mask0, key_padding_mask1
    if _16:
      why_not_fast_path3 = why_not_fast_path
    else:
      why_not_fast_path3 = ""
    is_batched = torch.eq(torch.dim(query), 3)
    key_padding_mask3 = _2(key_padding_mask0, "key_padding_mask", _1(attn_mask2, ), "attn_mask", ops.prim.dtype(query), True, )
    attn_mask4 = _2(attn_mask2, "attn_mask", None, "", ops.prim.dtype(query), False, )
    if torch.__not__(is_batched):
      why_not_fast_path5 = torch.format(_3, torch.dim(query))
      why_not_fast_path4, key_padding_mask4 = why_not_fast_path5, key_padding_mask3
    else:
      if torch.__isnot__(query, key):
        _20 = True
      else:
        _20 = torch.__isnot__(key, value)
      if _20:
        why_not_fast_path6, key_padding_mask5 = why_not_fast_path0, key_padding_mask3
      else:
        _21 = ops.prim.dtype(query)
        in_proj_bias = self.in_proj_bias
        _22 = torch.ne(_21, ops.prim.dtype(in_proj_bias))
        if _22:
          _23 = ops.prim.dtype(query)
          in_proj_bias0 = self.in_proj_bias
          why_not_fast_path8 = torch.format(_4, _23, ops.prim.dtype(in_proj_bias0))
          why_not_fast_path7, key_padding_mask6 = why_not_fast_path8, key_padding_mask3
        else:
          _24 = ops.prim.dtype(query)
          in_proj_weight = self.in_proj_weight
          _25 = ops.prim.dtype(in_proj_weight)
          if torch.ne(_24, _25):
            _26 = ops.prim.dtype(query)
            in_proj_weight0 = self.in_proj_weight
            _27 = ops.prim.dtype(in_proj_weight0)
            why_not_fast_path9, key_padding_mask7 = torch.format(_5, _26, _27), key_padding_mask3
          else:
            training = self.training
            if training:
              why_not_fast_path10, key_padding_mask8 = "training is enabled", key_padding_mask3
            else:
              num_heads = self.num_heads
              _28 = torch.remainder(num_heads, 2)
              if torch.ne(_28, 0):
                why_not_fast_path11, key_padding_mask9 = "self.num_heads is not even", key_padding_mask3
              else:
                bias_k = self.bias_k
                _29 = torch.__isnot__(bias_k, None)
                if _29:
                  why_not_fast_path12, key_padding_mask10 = "self.bias_k was not None", key_padding_mask3
                else:
                  bias_v = self.bias_v
                  _30 = torch.__isnot__(bias_v, None)
                  if _30:
                    why_not_fast_path13, key_padding_mask11 = "self.bias_v was not None", key_padding_mask3
                  else:
                    add_zero_attn = self.add_zero_attn
                    if add_zero_attn:
                      why_not_fast_path14, key_padding_mask12 = "add_zero_attn was enabled", key_padding_mask3
                    else:
                      _qkv_same_embed_dim = self._qkv_same_embed_dim
                      _31 = torch.__not__(_qkv_same_embed_dim)
                      if _31:
                        why_not_fast_path15, key_padding_mask13 = "_qkv_same_embed_dim was not True", key_padding_mask3
                      else:
                        _32 = ops.prim.is_nested(query)
                        if _32:
                          _34 = torch.__isnot__(key_padding_mask3, None)
                          if _34:
                            key_padding_mask16 = unchecked_cast(Tensor, key_padding_mask3)
                            _35, key_padding_mask15 = True, key_padding_mask16
                          else:
                            _36 = torch.__isnot__(attn_mask4, None)
                            _35, key_padding_mask15 = _36, key_padding_mask3
                          _33, key_padding_mask14 = _35, key_padding_mask15
                        else:
                          _33, key_padding_mask14 = False, key_padding_mask3
                        if _33:
                          why_not_fast_path16 = why_not_fast_path1
                        else:
                          _37 = torch.is_autocast_enabled()
                          if _37:
                            why_not_fast_path17 = "autocast is enabled"
                          else:
                            why_not_fast_path17 = why_not_fast_path3
                          why_not_fast_path16 = why_not_fast_path17
                        why_not_fast_path15, key_padding_mask13 = why_not_fast_path16, key_padding_mask14
                      why_not_fast_path14, key_padding_mask12 = why_not_fast_path15, key_padding_mask13
                    why_not_fast_path13, key_padding_mask11 = why_not_fast_path14, key_padding_mask12
                  why_not_fast_path12, key_padding_mask10 = why_not_fast_path13, key_padding_mask11
                why_not_fast_path11, key_padding_mask9 = why_not_fast_path12, key_padding_mask10
              why_not_fast_path10, key_padding_mask8 = why_not_fast_path11, key_padding_mask9
            why_not_fast_path9, key_padding_mask7 = why_not_fast_path10, key_padding_mask8
          why_not_fast_path7, key_padding_mask6 = why_not_fast_path9, key_padding_mask7
        why_not_fast_path6, key_padding_mask5 = why_not_fast_path7, key_padding_mask6
      why_not_fast_path4, key_padding_mask4 = why_not_fast_path6, key_padding_mask5
    _38 = torch.gt(torch.len(why_not_fast_path4), 0)
    if torch.__not__(_38):
      in_proj_weight1 = self.in_proj_weight
      in_proj_bias1 = self.in_proj_bias
      out_proj = self.out_proj
      weight = out_proj.weight
      out_proj0 = self.out_proj
      bias = out_proj0.bias
      if _6():
        why_not_fast_path19 = "we are running make_fx tracing"
      else:
        _41 = annotate(List[bool], [])
        _42 = torch.append(_41, _7(query, ))
        _43 = torch.append(_41, _7(key, ))
        _44 = torch.append(_41, _7(value, ))
        _45 = torch.append(_41, _7(in_proj_weight1, ))
        _46 = torch.append(_41, _7(in_proj_bias1, ))
        _47 = torch.append(_41, _7(weight, ))
        _48 = torch.append(_41, _7(bias, ))
        if torch.__not__(torch.all(_41)):
          why_not_fast_path21 = torch.format(_8, "privateuseone")
          why_not_fast_path20 = why_not_fast_path21
        else:
          if torch.is_grad_enabled():
            _50 = annotate(List[bool], [])
            _51 = torch.append(_50, _9(query, ))
            _52 = torch.append(_50, _9(key, ))
            _53 = torch.append(_50, _9(value, ))
            _54 = torch.append(_50, _9(in_proj_weight1, ))
            _55 = torch.append(_50, _9(in_proj_bias1, ))
            _56 = torch.append(_50, _9(weight, ))
            _57 = torch.append(_50, _9(bias, ))
            _49 = torch.any(_50)
          else:
            _49 = False
          if _49:
            why_not_fast_path22 = why_not_fast_path2
          else:
            why_not_fast_path22 = why_not_fast_path4
          why_not_fast_path20 = why_not_fast_path22
        why_not_fast_path19 = why_not_fast_path20
      _58 = torch.gt(torch.len(why_not_fast_path19), 0)
      if torch.__not__(_58):
        _61 = (self).merge_masks(attn_mask4, key_padding_mask4, query, )
        merged_mask, mask_type, = _61
        embed_dim = self.embed_dim
        num_heads0 = self.num_heads
        in_proj_weight2 = self.in_proj_weight
        in_proj_bias2 = self.in_proj_bias
        out_proj1 = self.out_proj
        weight0 = out_proj1.weight
        out_proj2 = self.out_proj
        bias0 = out_proj2.bias
        _62, _63 = torch._native_multi_head_attention(query, key, value, embed_dim, num_heads0, in_proj_weight2, in_proj_bias2, weight0, bias0, merged_mask, need_weights, average_attn_weights, mask_type)
        _59, _60 = True, (_62, _63)
      else:
        _59, _60 = False, _13
      _39, _40, why_not_fast_path18 = _59, _60, why_not_fast_path19
    else:
      _39, _40, why_not_fast_path18 = False, _13, why_not_fast_path4
    if _39:
      _64 = _40
    else:
      if ops.prim.is_nested(query):
        _65 = True
      else:
        _65 = ops.prim.is_nested(key)
      if _65:
        any_nested = True
      else:
        any_nested = ops.prim.is_nested(value)
      if torch.__not__(any_nested):
        pass
      else:
        _66 = torch.format(_10, why_not_fast_path18)
        _67 = torch.add("AssertionError: ", torch.add(_11, _66))
        ops.prim.RaiseException(_67)
      if is_batched:
        if torch.__is__(key, value):
          if torch.__is__(query, key):
            _68 = torch.transpose(query, 1, 0)
            query2, key2, value2 = _68, _68, _68
          else:
            _69 = annotate(List[Tensor], [])
            _70 = torch.transpose(query, 1, 0)
            _71 = torch.append(_69, _70)
            _72 = torch.append(_69, torch.transpose(key, 1, 0))
            query3, key3, = _69
            query2, key2, value2 = query3, key3, key3
          query1, key1, value1 = query2, key2, value2
        else:
          _73 = annotate(List[Tensor], [])
          _74 = torch.append(_73, torch.transpose(query, 1, 0))
          _75 = torch.append(_73, torch.transpose(key, 1, 0))
          _76 = torch.append(_73, torch.transpose(value, 1, 0))
          query4, key4, value3, = _73
          query1, key1, value1 = query4, key4, value3
        query0, key0, value0 = query1, key1, value1
      else:
        query0, key0, value0 = query, key, value
      _qkv_same_embed_dim0 = self._qkv_same_embed_dim
      _77 = torch.__not__(_qkv_same_embed_dim0)
      if _77:
        embed_dim0 = self.embed_dim
        num_heads1 = self.num_heads
        in_proj_weight3 = self.in_proj_weight
        in_proj_bias3 = self.in_proj_bias
        bias_k0 = self.bias_k
        bias_v0 = self.bias_v
        add_zero_attn0 = self.add_zero_attn
        dropout = self.dropout
        out_proj3 = self.out_proj
        weight1 = out_proj3.weight
        out_proj4 = self.out_proj
        bias1 = out_proj4.bias
        training0 = self.training
        q_proj_weight = self.q_proj_weight
        k_proj_weight = self.k_proj_weight
        v_proj_weight = self.v_proj_weight
        _78 = _12(query0, key0, value0, embed_dim0, num_heads1, in_proj_weight3, in_proj_bias3, bias_k0, bias_v0, add_zero_attn0, dropout, weight1, bias1, training0, key_padding_mask4, need_weights, attn_mask4, True, q_proj_weight, k_proj_weight, v_proj_weight, None, None, average_attn_weights, is_causal, )
        attn_output0, attn_output_weights0, = _78
        attn_output, attn_output_weights = attn_output0, attn_output_weights0
      else:
        embed_dim1 = self.embed_dim
        num_heads2 = self.num_heads
        in_proj_weight4 = self.in_proj_weight
        in_proj_bias4 = self.in_proj_bias
        bias_k1 = self.bias_k
        bias_v1 = self.bias_v
        add_zero_attn1 = self.add_zero_attn
        dropout0 = self.dropout
        out_proj5 = self.out_proj
        weight2 = out_proj5.weight
        out_proj6 = self.out_proj
        bias2 = out_proj6.bias
        training1 = self.training
        _79 = _12(query0, key0, value0, embed_dim1, num_heads2, in_proj_weight4, in_proj_bias4, bias_k1, bias_v1, add_zero_attn1, dropout0, weight2, bias2, training1, key_padding_mask4, need_weights, attn_mask4, False, None, None, None, None, None, average_attn_weights, is_causal, )
        attn_output1, attn_output_weights1, = _79
        attn_output, attn_output_weights = attn_output1, attn_output_weights1
      if is_batched:
        _81 = torch.transpose(attn_output, 1, 0)
        _80 = (_81, attn_output_weights)
      else:
        _82 = (attn_output, attn_output_weights)
        _80 = _82
      _64 = _80
    return _64
  def merge_masks(self: __torch__.torch.nn.modules.activation.MultiheadAttention,
    attn_mask: Optional[Tensor],
    key_padding_mask: Optional[Tensor],
    query: Tensor) -> Tuple[Optional[Tensor], Optional[int]]:
    _83 = torch.__isnot__(key_padding_mask, None)
    if _83:
      key_padding_mask18 = unchecked_cast(Tensor, key_padding_mask)
      key_padding_mask17, merged_mask, mask_type = key_padding_mask18, key_padding_mask18, 1
    else:
      key_padding_mask17, merged_mask, mask_type = key_padding_mask, None, None
    if torch.__isnot__(attn_mask, None):
      attn_mask5 = unchecked_cast(Tensor, attn_mask)
      batch_size, seq_len, _84, = torch.size(query)
      _85 = torch.eq(torch.dim(attn_mask5), 3)
      if _85:
        _86 = [batch_size, -1, seq_len, seq_len]
        attn_mask_expanded = torch.view(attn_mask5, _86)
      else:
        _87 = torch.view(attn_mask5, [1, 1, seq_len, seq_len])
        num_heads = self.num_heads
        attn_mask_expanded0 = torch.expand(_87, [batch_size, num_heads, -1, -1])
        attn_mask_expanded = attn_mask_expanded0
      _88 = torch.__isnot__(key_padding_mask17, None)
      if _88:
        key_padding_mask19 = unchecked_cast(Tensor, key_padding_mask17)
        _89 = torch.view(key_padding_mask19, [batch_size, 1, 1, seq_len])
        num_heads3 = self.num_heads
        key_padding_mask_expanded = torch.expand(_89, [-1, num_heads3, -1, -1])
        merged_mask2 = torch.add(attn_mask_expanded, key_padding_mask_expanded)
        merged_mask1 = merged_mask2
      else:
        merged_mask1 = attn_mask_expanded
      merged_mask0, mask_type0 = merged_mask1, 2
    else:
      merged_mask0, mask_type0 = merged_mask, mask_type
    return (merged_mask0, mask_type0)
def _is_make_fx_tracing() -> bool:
  return False
def _check_arg_device(x: Optional[Tensor]) -> bool:
  if torch.__isnot__(x, None):
    x0 = unchecked_cast(Tensor, x)
    _91 = ops.prim.type(ops.prim.device(x0))
    _92 = torch.__contains__(["cpu", "cuda", "privateuseone"], _91)
    _90 = _92
  else:
    _90 = True
  return _90
def _arg_requires_grad(x: Optional[Tensor]) -> bool:
  if torch.__isnot__(x, None):
    x1 = unchecked_cast(Tensor, x)
    _93 = ops.prim.requires_grad(x1)
  else:
    _93 = False
  return _93
